﻿using System;
using System.IO;
using System.Linq;
using System.Net;
using System.Xml.Linq;
using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;

namespace AppRestService
{
    [Activity(Label = "AppRestService", MainLauncher = true, Icon = "@drawable/icon")]
    public class Activity1 : Activity
    {
        int count = 1;

        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.Main);

            // Get our button from the layout resource,
            // and attach an event to it
            Button button = FindViewById<Button>(Resource.Id.MyButton);

            //button.Click += delegate { button.Text = string.Format("{0} clicks!", count++); };
            button.Click += delegate
                {
                    var rxcui = "198440";
                    var request = HttpWebRequest.Create(string.Format(@"http://rxnav.nlm.nih.gov/REST/RxTerms/rxcui/{0}/allinfo", rxcui));
                    //request.ContentType = "application/json";
                    request.ContentType = "application/xml";
                    request.Method = "GET";

                    using (HttpWebResponse response = request.GetResponse() as HttpWebResponse)
                    {
                        if (response.StatusCode != HttpStatusCode.OK)
                            Console.Out.WriteLine("Error fetching data. Server returned status code: {0}", response.StatusCode);
                        using (StreamReader reader = new StreamReader(response.GetResponseStream()))
                        {
                            var content = reader.ReadToEnd();
                            if (string.IsNullOrWhiteSpace(content))
                            {
                                Console.Out.WriteLine("Response contained empty body...");
                            }
                            else
                            {
                                Console.Out.WriteLine("Response Body: \r\n {0}", content);

                                var doc = XDocument.Parse(content);
                                var result = doc.Root.Descendants("rxtermsProperties")
                                .Select(x => new RxTerm()
                                {
                                    BrandName = x.Element("brandName").Value,
                                    DisplayName = x.Element("displayName").Value,
                                    Synonym = x.Element("synonym").Value,
                                    FullName = x.Element("fullName").Value,
                                    FullGenericName = x.Element("fullGenericName").Value,
                                    //bind more here...
                                    RxCUI = x.Element("rxcui").Value,
                                });

                                foreach (var rxTerm in result)
                                {
                                    var name = rxTerm.DisplayName;
                                }
                            }

                            //Assert.NotNull(content);
                        }
                    }
                };
        }
    }
}

