﻿using System;
using System.ServiceModel;
using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;

namespace AppWcfService
{
    [Activity(Label = "AppWcfService", MainLauncher = true, Icon = "@drawable/icon")]
    public class Activity1 : Activity
    {
        private MyServiceClient service;

        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.Main);

            // Get our button from the layout resource,
            // and attach an event to it
            Button button = FindViewById<Button>(Resource.Id.MyButton);

            var binding = new BasicHttpBinding()
            {
                Name = "basicHttpBinding",
                MaxReceivedMessageSize = 67108864,
            };

            binding.ReaderQuotas = new System.Xml.XmlDictionaryReaderQuotas()
            {
                MaxArrayLength = 2147483646,
                MaxStringContentLength = 5242880,
            };

            var timeout = new TimeSpan(0, 1, 0);
            binding.SendTimeout = timeout;
            binding.OpenTimeout = timeout;
            binding.ReceiveTimeout = timeout;

            //Setup the right address and enable the calls in the firewall
            service = new MyServiceClient(binding, new EndpointAddress("http://192.168.178.44:56009/MyService.svc"));


            button.Click += delegate
                {

                    service.AddDataCompleted += (sender, args) =>
                        {
                            var val = args.Result;
                        };
                    service.AddDataAsync(1, 2);
                };
        }
    }
}

